#ifndef LOAD_MY_COMMON
#define LOAD_MY_COMMON

#include <windows.h>
extern "C" {
#include "fitz.h"
#include "mupdf.h"
}
#define XMD_H
#define HAVE_BOOLEAN
#define NEED_FAR_POINTERS
#include "jpeglib.h"
#undef XMD_H
#undef HAVE_BOOLEAN
#undef NEED_FAR_POINTERS
#include "spi00am.h"

#include "critsect.h"

#define PATH_LENGTH (1024)
#define PASS_LENGTH (256)

struct CommonCache_Header {
	char name[PATH_LENGTH];
	char pass[PASS_LENGTH];
	unsigned long file_sum;
	int resolution;
	unsigned long start_addr;
};
struct CommonCache_Info {
	unsigned long position;
	unsigned long addr;//addr + start_addrۂ̃AhX
	unsigned long size;
};

//==== Format ====
//Header
//Info,Info,Info,...
//File,File,File,...
//================
class CommonCache
{
public:
	CommonCache();
	~CommonCache();
	void Init(char *archivename);
	void Clear();
	void Add(char *archivename, HLOCAL *hFile, unsigned long *filesize, unsigned long position);
		//hJpegɃt@Cf[^Ă
	int Get(char *archivename, HLOCAL *hFile, unsigned long *filesize, unsigned long position);
		//pinfoŎw肵positioñt@ChFileɓ(LocalAlloc)
	int Dupli(char *archivename, HLOCAL *lphInfo);
	void AddPassword(char *archivename, char *password);
	char* GetPassword(char *archivename);
private:
	CriticalSection cs;
	struct CommonCache_Header *now_header;
	struct CommonCache_Info *now_info;
	char temp[PATH_LENGTH];
};

int GetJpegToMemory(HLOCAL *hLocal, unsigned long *buf_size, pdf_xref *xref, pdf_page *page, int resolution);
void llog(char *s);
int GetArchiveInfoExCache(LPSTR filename, long len, HLOCAL *lphInf, CommonCache *cache);
void loadConfig();
int getPasswordSuggest(int num, char *buf, int len);
char *getFilename(LPSTR filename);

extern int g_resolution;
extern char iniFile[];
extern HANDLE g_hModule;
extern int g_isUseTemp;
extern char cacheFile[];
extern char cacheFile_temp[];

#if 0
#define MY_COMMON_DEBUG
#endif

#endif
